from pwn import *
from schnorr import *
import os
import hashlib
import ast
from base64 import *

p = remote('tcp.realworldctf.com', 20014)
#p = remote('localhost', 20014)

size = 21
proof = p.recvline()
proof = proof.split('starting with ')[1].strip()
print 'Must start with', proof.decode('base64')

def solvePow(start, sizeLeft):
	while 1:
		n = os.urandom(sizeLeft)
		t = start + n
		t = t[:21]

		ha = hashlib.sha1()
		ha.update(t)

		if ha.digest()[-1] == '\x00' and ha.digest()[-2] == '\x00':
			return t

proof = solvePow(proof, 5)
print proof, len(proof)
p.send(proof)

p.send('123,456'.encode('base64'))
p.send('3'.encode('base64')) #encode with base64 comes with newline included :)

a = p.recvuntil('But here is our public key just in case a random guy claims himself as one of us: ')
pk = p.recvuntil('\n').strip()
pk = ast.literal_eval(pk)

our_sk, our_pk = generate_keys()
fk = point_add(our_pk, point_inv(pk))

toSend = b64encode(str(our_pk[0])+','+str(our_pk[1]))
toSend2 = b64encode(str(fk[0])+','+str(fk[1]))

sig = schnorr_sign('DEPOSIT', our_sk)
sig2 = schnorr_sign('WITHDRAW', our_sk)

p.sendline(toSend)
p.send('1'.encode('base64'))
p.sendline(b64encode(sig))
p.sendline(toSend2)

print p.clean(timeout=1)
p.send('2'.encode('base64'))
p.sendline(b64encode(sig2))
p.interactive()